<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2010 YANMAH2 project
//This program is freesoftware. you can redistribute it and/or modify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php
define("HELLO","world");
require_once "product_definitions.php";
require_once "configurable_variables.php";
?>
<?php
ini_set('session.gc_maxlifetime', $session_file_lifetime);
ini_set('session.use_trans_sid', 0);
session_set_cookie_params($session_cookie_expire, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
if ($custom_session_save_path != 'default'){
	session_save_path($custom_session_save_path);
}
session_start();
//session_regenerate_id(TRUE);
?>
<?php
if ($extra_include_path != "default"){
	$default_include_path = ini_get("include_path");
	ini_set('include_path', ".:{$extra_include_path}:{$default_include_path}");
}
$selfcall = htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES);
$safequery = htmlspecialchars($_SERVER["QUERY_STRING"], ENT_QUOTES);
$http_url_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+';
$http_host_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;?:@&=+$,%#]+\/*';
$http_path_regexp = '[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]*';
mb_regex_encoding("UTF-8");
?>
<?php //セキュリティのための前処理。
//NULL バイトの入力を弾く
function checkNull($array){
	if (is_array($array)){
		return array_map('checkNull', $array);
	}
	if (preg_match('/\0/', $array)){
		echo "NULL ぽ";
		exit();
	}
}
checkNull($_GET);
checkNull($_POST);
checkNull($_COOKIE);
//長すぎる keyword
function checkKeyword($element){
	if (strlen(bin2hex($element)) > 511){
		echo "キーワードが長すぎて入らないです…\n(YANMAH2: キーワードの指定に関するエラー)";
		exit();
	}
}
if ($_GET["keyword"] != ''){
	checkKeyword($_GET["keyword"]);
}
//不正なはてなID
//正しいはてなID＝アルファベットで始まり、アルファベットか数字で終わる3文字以上､32文字以内の半角英数字
function checkId($element){
	if (preg_match("/^[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1}$/u" ,$element) == 0){
		echo "だれですか\n(YANMAH2: はてなIDの指定に関するエラー)";
		exit();
	}
}
if ($_GET["user"] != ''){
	checkId($_GET["user"]);
}
if ($_GET["following"] != ''){
	checkId($_GET["following"]);
}
//不正な page
//page=n は100までの数値であること。
function checkPagenum($element){
	if (preg_match("/^[1234567890]{1,3}$/u",$element) == 0){
		echo "数字以外入れちゃだめ\n(YANMAH2: ページ数に関するエラー)";
		exit();
	}
	if ($element > 100){
		echo "ページ数が大きすぎです…\n(YANMAH2: ページ数に関するエラー)";
		exit();
	}
}
if ($_GET[page] != ''){
	checkPagenum($_GET[page]);
}
function checkImagemode($element){
	if (!preg_match('/^(on|off)$/u', $element)){
		echo 'んっ！？　って思うパラメータは処理しないし。（YANMAH2: 画像モードに関するエラー）';
		exit();
	}
}
if ($_GET['image'] == ''){
} else {
	checkImagemode($_GET['image']);
}
if ($_SESSION['image'] == ''){
} else {
	checkImagemode($_SESSION['image']);
}
function checkAlbum($element){
	if (strlen(bin2hex($element)) > 514){
	echo "はうあ\n";
	exit();
}
}
if ($_GET['album'] == ''){
} else {
	checkAlbum($_GET['album']);
}
?>
<?php
//投稿処理の呼び出し。
//var_dump($_POST);
if ($_POST['posting'] == 'try'){
//	var_dump($_POST['posting']);
	session_regenerate_id(TRUE);
	require 'post_processor.php';
	header('HTTP/1.1 303 See Other');
	header('Location: ' . $_POST['return']);
	exit();

}
//スター処理の呼び出し。
if ($_POST['posting'] != 'try' && $_POST['star'] == 'add'){
	session_regenerate_id(TRUE);
	require 'post_processor.php';
	header('HTTP/1.1 303 See Other');
	header('Location: ' . $_POST['return']);
	exit();
}
?>
<?php
//前置きはこのくらいにして、本題に入る！
require_once "HTTP/Request.php";

if ($_GET["keyword"] != ''){
	$get_keyword = htmlspecialchars($_GET["keyword"], ENT_QUOTES);
	$json_url = "http://h.hatena.ne.jp/api/statuses/keyword_timeline/" . rawurlencode($_GET['keyword']) . ".json";
	$page_head = $get_keyword . " でひとこと";
	$official = "{$haiku_official_url}keyword/" . rawurlencode($_GET['keyword']);
	$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?keyword=" . rawurlencode($_GET['keyword']);
	$entries_mode = 'keyword_timeline';
}	elseif ($_GET["user"] != ''){
		$get_user = htmlspecialchars($_GET["user"], ENT_QUOTES);
		$json_url = "http://h.hatena.ne.jp/api/statuses/user_timeline/{$get_user}.json";
		$page_head = "{$get_user} さんのエントリー";
		$official = "{$haiku_official_url}{$get_user}/";
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?user={$get_user}";
		$entries_mode = 'user_timeline';
}	elseif ($_GET["following"] != ''){
		$get_following = htmlspecialchars($_GET["following"], ENT_QUOTES);
		$json_url = "http://h.hatena.ne.jp/api/statuses/friends_timeline/{$get_following}.json";
		$page_head = "{$get_following} さんのアンテナ";
		$official = "{$haiku_official_url}following";
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?following={$get_following}";
		$entries_mode = 'friends_timeline';
}	elseif ($_GET['album'] != ''){
	if ($_GET['album'] == 'public'){
		$json_url = 'http://h.hatena.ne.jp/api/statuses/album.json';
		$page_head = 'みんなのアルバム';
		$official = $haiku_official_url . 'album';
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?album=public";
		$entries_mode = 'album';
	} else{
	}
}	else {
	$json_url = "http://h.hatena.ne.jp/api/statuses/public_timeline.json";
	$page_head = "みんなのエントリー";
	$official = $haiku_official_url;
	$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}";
	$entries_mode = 'default';
}
if ($_GET['page'] != ''){
	if ($entries_mode == 'default'){
		$self_anchor_possibly_with_pagenum = $self_anchor . '?page=' . $_GET['page'];
	} else {
		$self_anchor_possibly_with_pagenum = $self_anchor . '&amp;page=' . $_GET['page'];
	}
} else {
	$self_anchor_possibly_with_pagenum = $self_anchor;
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />
	<?php echo "<title>{$page_head} - {$site_name}{$site_name_caption}</title>\n"; ?>
	<link rel="stylesheet" href="./found.css" />
	<link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
	<link rel="shortcut icon" href="./favicon.ico" type="image/vnd.microsoft.icon" /></head>
<body>
<div id="page">
<?php
//var_dump($_GET);
echo "<div id=\"header\" class=\"{$entries_mode}\">\n";
echo "<h1 id=\"entries-head\" class=\"head1\">{$page_head} <a href=\"{$official}\" class=\"to-original-link\">&nbsp;‡&nbsp;</a></h1>\n<hr />";
echo "</div>\n";
?>
<?php
if ($_SESSION['auth'] === TRUE){
	echo '<div class="post-box">';
	echo '<form method="post" action="" enctype="application/x-www-form-urlencoded">';
	if ($entries_mode == 'keyword_timeline'){
		echo '<input type="hidden" id="post-keyword" name="keyword" value="' . $get_keyword . '" />';
	} else {
		echo '<input type="text" id="post-keyword" name="keyword" maxlength="170" value="' . $get_keyword . '" /><br />';
	}
	echo <<<EOL
<textarea id="post-text" name="status" rows="3" cols="20"></textarea><br />
<input type="hidden" name="posting" value="try" />
<input type="hidden" name="return" value="{$self_anchor_possibly_with_pagenum}" />
<input type="submit" id="post-haiku" value="Haiku!" />
<label for="post-from"> from </label><input type="text" id="post-from" name="source" value="{$product_name_abbr}" maxlength="170" />
</form>
EOL;
	if ($_SESSION['post_result'] == 'success'){
		echo '<span>' . $_SESSION['post_result_mes'] . '</span>';
	}
	if ($_SESSION['post_result'] == 'failed'){
		echo '<span>' . $_SESSION['post_result_mes'] . '</span>';
		echo $_SESSION['post_error'];
	}
	echo '</div>';
	$_SESSION['post_result'] = '';
	$_SESSION['post_result_mes'] = '';
	$_SESSION['post_error'] = '';
}
?>
<div class="contents">
<?php
if ($_GET["page"] === ''){
	$request_url = $json_url;
}	else {
		$request_url = $json_url . "?page=" . htmlspecialchars($_GET["page"], ENT_QUOTES);
}
if (isset($_GET['image'])){
	$_SESSION['image'] = $_GET['image'];
}
$req =& new HTTP_Request($request_url);

if (!PEAR::isError($req->sendRequest())) {
	$json = $req->getResponseBody();
	$contents = json_decode($json,true);
	if (is_array($contents)){
	}	else {
			echo "<blockquote>{$json}</blockquote>";
			exit();
		}
//	echo "<pre>" . var_dump($contents) . "</pre>";
	$entry_processor_mode = "entries";
	foreach ($contents as $val){
	require 'entry_processor.php';
	}
}
?>
</div>
<ul class="navigation-menu">
<?php
if ($_GET[page] != ''){
	if ($_GET[page] >= 100){
		$next_query = preg_replace('/page=[0123456789]{1,3}/u',"page=1",$safequery);
		$next_url = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?$next_query";
		$next_num = 1;
	}	else {
			$next_num = $_GET[page] + 1;
			$next_query = preg_replace('/page=[0123456789]{1,3}/u',"page={$next_num}",$_SERVER["QUERY_STRING"]);
			$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . htmlspecialchars($next_query, ENT_QUOTES);
		}
}	elseif ($_SERVER["QUERY_STRING"] != ""){
		$next_num = 2;
		$next_query = $_SERVER["QUERY_STRING"] . "&page=" . $next_num;
		$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . htmlspecialchars($next_query, ENT_QUOTES);
}	else {
		$next_num = 2;
		$next_query = "page=" . $next_num;
		$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $next_query;
}
if ($next_num == 1){
	$current_page = 100;
} else {
	$current_page = $next_num - 1;
}
if ($_GET['page'] != ''){
	if ($_GET['page'] <= 1){
		$prev_query = preg_replace('/page=[0123456789]{1,3}/u',"page=100",$safequery);
		$prev_url = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?$prev_query";
		$prev_num = 100;
	} else {
		$prev_num = $_GET['page'] - 1;
		$prev_query = preg_replace('/page=[0123456789]{1,3}/u',"page={$prev_num}",$_SERVER["QUERY_STRING"]);
		$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
	}
} elseif ($_SERVER['QUERY_STRING'] != ''){
	$prev_num = 100;
	$prev_query = $safequery . '&amp;page=' . $prev_num;
	$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
} else {
	$prev_num = 100;
	$prev_query = 'page=' . $prev_num;
	$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
}
?>
<?php
if ($_GET['image'] != ''){
	$qimagemode = '?image=' . $_GET['image'];
} else {
	$qimagemode = '';
}

echo "<li>この頁は " . $current_page . " ページ</li>";

echo "<li>";
echo "[1]<a href=\"{$self_anchor}\" class=\"navigation-link\" accesskey=\"1\">最初の頁</a> ";
echo "[2]<a href=\"./entries.php\" class=\"navigation-link\" accesskey=\"2\">Entries</a> ";
echo "[3]<a href=\"mailto:?subject=" . htmlspecialchars($_GET["keyword"], ENT_QUOTES) . "\" class=\"navigation-link\" accesskey=\"3\">メール</a></li>";

echo "<li>";
echo "[4]<a href=\"{$prev_url}\" class=\"navigation-link\" accesskey=\"4\">前へ(p{$prev_num})</a> ";
if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on'){
	if (preg_match('/^image=on$/u', $_SERVER['QUERY_STRING'])){
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '?image=off';
	} elseif ($_SERVER["QUERY_STRING"] != ""){
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '&amp;image=off';
	} else {
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '?image=off';
	}
	echo '[5]<a href="' . $self_anchor_with_imagemode .  '" class="navigation-link" accesskey="5">画像省略</a> ';
} elseif ($_GET['image'] == 'off' || $_SESSION['image'] == 'off' || $_GET['image'] == '' || $_SESSION['image'] == ''){
	if (preg_match('/^image=off$/u', $_SERVER['QUERY_STRING'])){
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '?image=on';
	} elseif ($_SERVER["QUERY_STRING"] != ""){
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '&amp;image=on';
	} else {
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '?image=on';
	}
	echo '[5]<a href="' . $self_anchor_with_imagemode . '" class="navigation-link" accesskey="5">画像表示</a> ';
}
echo "[6]<a href=\"{$next_url}\" class=\"navigation-link\" accesskey=\"6\">次へ(p{$next_num})</a></li>";

echo '<li>';
if ($_SESSION['auth'] === TRUE){
	echo "[7]<a href=\"./keywords.php?user={$_SESSION['hatenaid']}\" class=\"navigation-link\" accesskey=\"7\">Keywords</a> ";
	echo "[8]<a href=\"./entries.php?following={$_SESSION['hatenaid']}\" class=\"navigation-link\" accesskey=\"8\">アンテナ</a> ";
	echo '[9]<a href="./index.php" class="navigation-link" accesskey="9">トップ</a>';
} else {
	echo '[7]<a href="./keywords.php" class="navigation-link" accesskey="7">Keywords</a>';
	echo '[8] ---  ';
	echo '[9]<a href="./index.php" class="navigation-link" accesskey="9">トップ</a>';
}
echo '</li>';

echo '<li>';
if ($_SESSION['auth'] === TRUE){
	echo '[0]<a href="./login.php?log=out" class="navigation-link" accesskey="0">ログアウト</a>';
} else {
	echo '[0]<a href="./login.php?return=' . rawurlencode($self_anchor_possibly_with_pagenum) . '" class="navigation-link" accesskey="0">ログイン</a>';
}
echo '</li>';

?>
</ul>
<hr />
<?php
echo $footer;
?>
</div>
</body>
</html>
